precision mediump float;
uniform sampler2D InputTextureSampler;
uniform sampler2D LookupTexSampler;
varying vec2 VSOutTexCoord;
uniform float intensity;
uniform float showOrigin;

void main(){
  if (showOrigin == 1.0) {
      gl_FragColor = texture2D(InputTextureSampler,VSOutTexCoord);
  } else {
      vec4 texColour = texture2D(InputTextureSampler,VSOutTexCoord);
      float blueColor = texColour.b * 63.0;
      vec2 quad1;
      quad1.y = floor(floor(blueColor) / 8.0);
      quad1.x = floor(blueColor) - (quad1.y * 8.0);
      vec2 quad2;
      quad2.y = floor(ceil(blueColor) / 8.0);
      quad2.x = ceil(blueColor) - (quad2.y * 8.0);
      vec2 texPos1;
      texPos1.x = (quad1.x * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * texColour.r);
      texPos1.y = (quad1.y * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * texColour.g);
      vec2 texPos2;
      texPos2.x = (quad2.x * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * texColour.r);
      texPos2.y = (quad2.y * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * texColour.g);
      vec4 newColor1 = texture2D(LookupTexSampler, texPos1);
      vec4 newColor2 = texture2D(LookupTexSampler, texPos2);
      vec4 newColor = mix(newColor1, newColor2, fract(blueColor));
      gl_FragColor = mix(texColour, vec4(newColor.rgb, texColour.a), intensity);
  }
}