attribute vec2		Position0;
attribute vec2		Texcoord0;
varying vec2		VSOutTexCoord;

varying vec4 textureShift_1;
varying vec4 textureShift_2;
varying vec4 textureShift_3;
varying vec4 textureShift_4;

uniform float texelWidthOffset1;
uniform float texelHeightOffset1;

void main(void)
{
	gl_Position = vec4(Position0, 0.0, 1.0);
	VSOutTexCoord = Texcoord0;

	vec2 singleStepOffset = vec2(texelWidthOffset1, texelHeightOffset1);
	textureShift_1 = vec4(Texcoord0.xy - singleStepOffset, Texcoord0.xy + singleStepOffset);
	textureShift_2 = vec4(Texcoord0.xy - 2.0 * singleStepOffset, Texcoord0.xy + 2.0 * singleStepOffset);
	textureShift_3 = vec4(Texcoord0.xy - 3.0 * singleStepOffset, Texcoord0.xy + 3.0 * singleStepOffset);
	textureShift_4 = vec4(Texcoord0.xy - 4.0 * singleStepOffset, Texcoord0.xy + 4.0 * singleStepOffset);
}