--
-- Created by IntelliJ IDEA.
-- User: momo
-- Date: 2018/7/25
-- Time: 10:34 AM
-- To change this template use File | Settings | File Templates.
--

_G_Director = xe.Director:GetInstance()
function xe.Director:GetInstance()
    return _G_Director
end
_G_EngineInstance = _G_Director:GetEngine()
_G_AudioEngine = _G_EngineInstance:GetAudioManager()

function XEEngineInstance:SetNativeViewRenderSize(w, h)
    pcall(
        function()
            xe.ScriptBridge:call("XERenderViewHandler", "setRenderSizeFromScript", string.format("%dx%d", w, h))
        end
    )
end

function XEEngineInstance:GetNativeViewRenderSize()
    return self:GetPlatformWindow():GetWidth(), self:GetPlatformWindow():GetHeight()
end

function XEWorld:CloneActor(pActor, name)
    local pActor2 = pActor:SpawnCloneActor()
    if type(name) == "string" then
        pActor2:SetActorName(name, self)
    end
    return pActor2
end

local __XEWorld_CreateActor__ = XEWorld.CreateActor
function XEWorld:CreateActor(...)
    local actor = __XEWorld_CreateActor__(self, ...)
    if actor then
        return actor, actor:GetRootComponent()
    end
end

local __XUIVirtualListView_SetVirtualListDelegate__ = XUIVirtualListView.SetVirtualListDelegate
function XUIVirtualListView:SetVirtualListDelegate(delegate)
    self._m_delegate = delegate
    __XUIVirtualListView_SetVirtualListDelegate__(self, delegate)
end

local __XUIDynamicListView_SetDynamicListDelegate__ = XUIDynamicListView.SetDynamicListDelegate
function XUIDynamicListView:SetDynamicListDelegate(delegate)
    self._m_delegate = delegate
    __XUIDynamicListView_SetDynamicListDelegate__(self, delegate)
end

local __XUIEditBox_SetDelegate__ = XUIEditBox.SetDelegate
function XUIEditBox:SetDelegate(delegate)
    self._m_delegate = delegate
    __XUIEditBox_SetDelegate__(self, delegate)
end

-- 过期代码
xe = xe or xes
ar = ar or AR
xe.App = xe.App or {}
xe.App.Platform = xe.Director:GetPlatform()
xe.PLATFORM_OS_NONE = 0
xe.PLATFORM_OS_IOS = 1
xe.PLATFORM_OS_ANDROID = 2

function xe.Scene:ctor(sceneID)
    local instasnce = xe.Scene:CreateScene(sceneID)

    instasnce.StartTick = function()
        print_warning("xe.Scene:StartTick方法已过期")
    end
    instasnce.startTick = instasnce.StartTick
    instasnce.StopTick = function()
        print_warning("xe.Scene:StopTick方法已过期")
    end

    return instasnce
end

function xe.Class(...)
    print_warning("xe:Class 已被标记过期 请尽快使用 XLuaClass 代替")
    return XLuaClass("UnnamedClass", ...)
end

function xe.XClass(...)
    print_warning("xe:XClass 已被标记过期 请尽快使用 XLuaClass 代替")
    return XLuaClass(...)
end

function XLuaClass(classname, ...)
    local clazz = {XClassName = classname}

    local supers = {...}
    for _, super in ipairs(supers) do
        local superType = type(super)
        if superType == "function" then
            clazz.__create = super
        elseif superType == "table" then
            if super.isCClass then
                -- super is native class
                clazz.__create = function(...)
                    return super:ctor(...)
                end
            else
                -- super is pure lua class
                clazz.__supers = clazz.__supers or {}
                clazz.__supers[#clazz.__supers + 1] = super
                if not clazz.super then
                    -- set first super pure lua class as class.super
                    clazz.super = super
                end
            end
        else
            print_warning(string.format('class() - create class "%s" with invalid super type', classname), 0)
        end
    end

    clazz.__index = clazz
    if not clazz.__supers or #clazz.__supers == 1 then
        setmetatable(clazz, {__index = clazz.super})
    else
        setmetatable(
            clazz,
            {
                __index = function(_, key)
                    local supers = clazz.__supers
                    for i = 1, #supers do
                        local super = supers[i]
                        if super[key] then
                            return super[key]
                        end
                    end
                end
            }
        )
    end

    function clazz:new(...)
        local instance
        if clazz.__create then
            instance = clazz.__create(...)
        else
            instance = {}
        end
        setmetatableindex(instance, clazz)
        instance.class = clazz
        if instance.onCreate then
            instance:onCreate(...)
        end
        return instance
    end

    return clazz
end
